diff --git a/src/krb5pa-md5_fmt_plug.c b/src/krb5pa-md5_fmt_plug.c
index 3fb399f69a..6bb890d95a 100644
--- a/src/krb5pa-md5_fmt_plug.c
+++ b/src/krb5pa-md5_fmt_plug.c
@@ -98,9 +98,9 @@ john_register_one(&fmt_mskrb5);
 
 #define HEXCHARS           "0123456789abcdefABCDEF"
 
-// Second and third plaintext will be replaced in init() under --encoding=utf8
+// Second and third plaintext will be replaced in init() under come encodings
 static struct fmt_tests tests[] = {
-	{"$krb5pa$23$user$realm$$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7daeb03b6fbcfe91f8346f3c0ae7e8abfe5", "John"},
+	{"$krb5pa$23$user$realm$salt$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7daeb03b6fbcfe91f8346f3c0ae7e8abfe5", "John"},
 	{"$mskrb5$john$JOHN.DOE.MS.COM$02E837D06B2AC76891F388D9CC36C67A$2A9785BF5036C45D3843490BF9C228E8C18653E10CE58D7F8EF119D2EF4F92B1803B1451", "fr2beesgr"},
 	{"$mskrb5$user1$EXAMPLE.COM$08b5adda3ab0add14291014f1d69d145$a28da154fa777a53e23059647682eee2eb6c1ada7fb5cad54e8255114270676a459bfe4a", "openwall"},
 	{"$mskrb5$hackme$EXAMPLE.NET$e3cdf70485f81a85f7b59a4c1d6910a3$6e2f6705551a76f84ec2c92a9dd0fef7b2c1d4ca35bf1b02423359a3ecaa19bdf07ed0da", "openwall@123"},
@@ -191,18 +191,21 @@ static char *split(char *ciphertext, int index, struct fmt_main *self)
 
 	if (!strncmp(ciphertext, "$mskrb5$", 8)) {
 		char in[TOTAL_LENGTH + 1];
-		char *u, *r, *c, *t;
+		char *c, *t;
 
-		strnzcpy(in, ciphertext, sizeof(out));
+		strnzcpy(in, ciphertext, sizeof(in));
 
 		t = strrchr(in, '$'); *t++ = 0;
 		c = strrchr(in, '$'); *c++ = 0;
-		r = strrchr(in, '$'); *r++ = 0;
-		u = in + 8;
 
-		snprintf(out, sizeof(out), "$krb5pa$23$%s$%s$$%s%s", u, r, t, c);
-	} else
-		strnzcpy(out, ciphertext, sizeof(out));
+		snprintf(out, sizeof(out), "$krb5pa$23$$$$%s%s", t, c);
+	} else {
+		char *tc;
+
+		tc = strrchr(ciphertext, '$');
+
+		snprintf(out, sizeof(out), "$krb5pa$23$$$$%s", ++tc);
+	}
 
 	data = out + strlen(out) - 2 * (CHECKSUM_SIZE + TIMESTAMP_SIZE) - 1;
 	strlwr(data);
diff --git a/src/krb5pa-sha1_fmt_plug.c b/src/krb5pa-sha1_fmt_plug.c
index 36f1601a40..c59b287605 100644
--- a/src/krb5pa-sha1_fmt_plug.c
+++ b/src/krb5pa-sha1_fmt_plug.c
@@ -95,6 +95,7 @@ static struct fmt_tests tests[] = {
 	{"$krb5pa$18$user1$EXAMPLE.COM$$a3918bd0381107feedec8db0022bdf3ac56e534ed54d13c62a7013a47713cfc31ef4e7e572f912fa4164f76b335e588bf29c2d17b11c5caa", "openwall"},
 	{"$krb5pa$18$l33t$EXAMPLE.COM$$98f732b309a1d7ef2355a974842a32894d911e97150f5d57f248e1c2632fbd3735c5f156532ccae0341e6a2d779ca83a06021fe57dafa464", "openwall"},
 	{"$krb5pa$18$aduser$AD.EXAMPLE.COM$$64dfeee04be2b2e0423814e0df4d0f960885aca4efffe6cb5694c4d34690406071c4968abd2c153ee42d258c5e09a41269bbcd7799f478d3", "password@123"},
+	{"$krb5pa$18$aduser$AD.EXAMPLE.COM$$f94f755a8b4493d925094a4eb1cec630ac40411a14c9733a853516fe426637d9daefdedc0567e2bb5a83d4f89a0ad1a4b178662b6106c0ff", "password@12345678"},
 	{"$krb5pa$18$aduser$AD.EXAMPLE.COM$AD.EXAMPLE.COMaduser$f94f755a8b4493d925094a4eb1cec630ac40411a14c9733a853516fe426637d9daefdedc0567e2bb5a83d4f89a0ad1a4b178662b6106c0ff", "password@12345678"},
 	/* etype 17 hash obtained using MiTM etype downgrade attack */
 	{"$krb5pa$17$user1$EXAMPLE.COM$$c5461873dc13665771b98ba80be53939e906d90ae1ba79cf2e21f0395e50ee56379fbef4d0298cfccfd6cf8f907329120048fd05e8ae5df4", "openwall"},
@@ -319,7 +320,7 @@ static void *get_salt(char *ciphertext)
 		strcpy((char*)cs.salt, p);
 		p = strtok(NULL, "$");
 	}
-	for (i = 0; i < 44; i++)
+	for (i = 0; i < TIMESTAMP_SIZE; i++)
 		cs.ct[i] = atoi16[ARCH_INDEX(p[i * 2])] * 16
 			+ atoi16[ARCH_INDEX(p[i * 2 + 1])];
 	MEM_FREE(keeptr);
@@ -338,9 +339,26 @@ static void set_key(char *key, int index)
 static char *split(char *ciphertext, int index, struct fmt_main *pFmt)
 {
 	static char out[TOTAL_LENGTH + 1];
+	char in[TOTAL_LENGTH + 1];
+	char salt[MAX_SALTLEN + 1];
 	char *data;
+	char *e, *u, *r, *s, *tc;
+
+	strnzcpy(in, ciphertext, sizeof(in));
+
+	tc = strrchr(in, '$'); *tc++ = 0;
+	s = strrchr(in, '$'); *s++ = 0;
+	r = strrchr(in, '$'); *r++ = 0;
+	u = strrchr(in, '$'); *u++ = 0;
+	e = in + 8;
+
+	/* Default salt is user.realm */
+	if (!*s) {
+		snprintf(salt, sizeof(salt), "%s%s", r, u);
+		s = salt;
+	}
+	snprintf(out, sizeof(out), "$krb5pa$%s$%s$%s$%s$%s", e, u, r, s, tc);
 
-	strnzcpy(out, ciphertext, sizeof(out));
 	data = out + strlen(out) - 2 * (CHECKSUM_SIZE + TIMESTAMP_SIZE) - 1;
 	strlwr(data);
 
@@ -357,7 +375,7 @@ static void *get_binary(char *ciphertext)
 	char *p;
 	int i;
 
-	p = strrchr(ciphertext, '$') + 1 + 44 * 2; /* skip to checksum field */
+	p = strrchr(ciphertext, '$') + 1 + TIMESTAMP_SIZE * 2; /* skip to checksum field */
 	for (i = 0; i < BINARY_SIZE; i++) {
 		out[i] =
 		    (atoi16[ARCH_INDEX(*p)] << 4) |
diff --git a/src/opencl_krb5pa-md5_fmt_plug.c b/src/opencl_krb5pa-md5_fmt_plug.c
index af0b2c1468..55f411e7f4 100644
--- a/src/opencl_krb5pa-md5_fmt_plug.c
+++ b/src/opencl_krb5pa-md5_fmt_plug.c
@@ -8,6 +8,10 @@
  * 2. krbng2john.py ~/capture.pdml > krb5.in
  * 3. Run john on krb5.in
  *
+ * Legacy input format:
+ * user:$mskrb5$user$realm$checksum$timestamp
+ *
+ * New input format from krbpa2john.py (the above is still supported)
  * user:$krb5pa$etype$user$realm$salt$timestamp+checksum
  *
  * user, realm and salt are unused in this format.
@@ -72,7 +76,7 @@ john_register_one(&fmt_opencl_krb5pa_md5);
 
 #define HEXCHARS           "0123456789abcdefABCDEF"
 
-// Second and third plaintext will be replaced in init() under --encoding=utf8
+// Second and third plaintext will be replaced in init() under come encodings
 static struct fmt_tests tests[] = {
 	{"$krb5pa$23$user$realm$salt$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7daeb03b6fbcfe91f8346f3c0ae7e8abfe5", "John"},
 	{"$mskrb5$john$JOHN.DOE.MS.COM$02E837D06B2AC76891F388D9CC36C67A$2A9785BF5036C45D3843490BF9C228E8C18653E10CE58D7F8EF119D2EF4F92B1803B1451", "fr2beesgr"},
@@ -80,7 +84,7 @@ static struct fmt_tests tests[] = {
 	{"$mskrb5$hackme$EXAMPLE.NET$e3cdf70485f81a85f7b59a4c1d6910a3$6e2f6705551a76f84ec2c92a9dd0fef7b2c1d4ca35bf1b02423359a3ecaa19bdf07ed0da", "openwall@123"},
 	{"$mskrb5$$$98cd00b6f222d1d34e08fe0823196e0b$5937503ec29e3ce4e94a051632d0fff7b6781f93e3decf7dca707340239300d602932154", ""},
 	{"$mskrb5$$$F4085BA458B733D8092E6B348E3E3990$034ACFC70AFBA542690B8BC912FCD7FED6A848493A3FF0D7AF641A263B71DCC72902995D", "frank"},
-	{"$mskrb5$$$eb03b6fbcfe91f8346f3c0ae7e8abfe5$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7da", "John"},
+	{"$mskrb5$user$realm$eb03b6fbcfe91f8346f3c0ae7e8abfe5$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7da", "John"},
 	{"$mskrb5$$$881c257ce5df7b11715a6a60436e075a$c80f4a5ec18e7c5f765fb9f00eda744a57483db500271369cf4752a67ca0e67f37c68402", "the"},
 	{"$mskrb5$$$ef012e13c8b32448241091f4e1fdc805$354931c919580d4939421075bcd50f2527d092d2abdbc0e739ea72929be087de644cef8a", "Ripper"},
 #if PLAINTEXT_LENGTH >= 31
@@ -445,8 +449,6 @@ static void *salt(char *ciphertext)
 	int i;
 
 	p = strrchr(ciphertext, '$') + 1;
-	if (strlen(p) == 2 * (TIMESTAMP_SIZE + CHECKSUM_SIZE)) {
-		// New input format
 		for (i = 0; i < TIMESTAMP_SIZE; i++) {
 			salt.timestamp[i] =
 				(atoi16[ARCH_INDEX(*p)] << 4) |
@@ -458,23 +460,6 @@ static void *salt(char *ciphertext)
 				(atoi16[ARCH_INDEX(*p)] << 4) |
 				atoi16[ARCH_INDEX(p[1])];
 			p += 2;
-		}
-	} else {
-		// Old input format
-		p -= (2 * CHECKSUM_SIZE + 1);
-		for (i = 0; i < CHECKSUM_SIZE; i++) {
-			((unsigned char*)salt.checksum)[i] =
-				(atoi16[ARCH_INDEX(*p)] << 4) |
-				atoi16[ARCH_INDEX(p[1])];
-			p += 2;
-		}
-		++p;
-		for (i = 0; i < TIMESTAMP_SIZE; i++) {
-			salt.timestamp[i] =
-				(atoi16[ARCH_INDEX(*p)] << 4) |
-				atoi16[ARCH_INDEX(p[1])];
-			p += 2;
-		}
 	}
 	return (void*)&salt;
 }
@@ -599,7 +584,24 @@ static char *split(char *ciphertext, int index, struct fmt_main *self)
 	static char out[TOTAL_LENGTH + 1];
 	char *data;
 
-	strnzcpy(out, ciphertext, sizeof(out));
+	if (!strncmp(ciphertext, "$mskrb5$", 8)) {
+		char in[TOTAL_LENGTH + 1];
+		char *c, *t;
+
+		strnzcpy(in, ciphertext, sizeof(in));
+
+		t = strrchr(in, '$'); *t++ = 0;
+		c = strrchr(in, '$'); *c++ = 0;
+
+		snprintf(out, sizeof(out), "$krb5pa$23$$$$%s%s", t, c);
+	} else {
+		char *tc;
+
+		tc = strrchr(ciphertext, '$');
+
+		snprintf(out, sizeof(out), "$krb5pa$23$$$$%s", ++tc);
+	}
+
 	data = out + strlen(out) - 2 * (CHECKSUM_SIZE + TIMESTAMP_SIZE) - 1;
 	strlwr(data);
 
@@ -615,12 +617,7 @@ static void *binary(char *ciphertext)
 	if (!binary) binary = mem_alloc_tiny(BINARY_SIZE, MEM_ALIGN_WORD);
 
 	p = strrchr(ciphertext, '$') + 1;
-	if (strlen(p) == 2 * (TIMESTAMP_SIZE + CHECKSUM_SIZE))
-		// New input format
 		p += 2 * TIMESTAMP_SIZE;
-	else
-		// Old input format
-		p -= (2 * CHECKSUM_SIZE + 1);
 
 	for (i = 0; i < CHECKSUM_SIZE; i++) {
 		binary[i] =
diff --git a/src/opencl_krb5pa-sha1_fmt_plug.c b/src/opencl_krb5pa-sha1_fmt_plug.c
index f41f0f1929..6c6d7e3f99 100644
--- a/src/opencl_krb5pa-sha1_fmt_plug.c
+++ b/src/opencl_krb5pa-sha1_fmt_plug.c
@@ -645,9 +645,26 @@ static char* get_key(int index)
 static char *split(char *ciphertext, int index, struct fmt_main *pFmt)
 {
 	static char out[TOTAL_LENGTH + 1];
+	char in[TOTAL_LENGTH + 1];
+	char salt[MAX_SALTLEN + 1];
 	char *data;
+	char *e, *u, *r, *s, *tc;
+
+	strnzcpy(in, ciphertext, sizeof(in));
+
+	tc = strrchr(in, '$'); *tc++ = 0;
+	s = strrchr(in, '$'); *s++ = 0;
+	r = strrchr(in, '$'); *r++ = 0;
+	u = strrchr(in, '$'); *u++ = 0;
+	e = in + 8;
+
+	/* Default salt is user.realm */
+	if (!*s) {
+		snprintf(salt, sizeof(salt), "%s%s", r, u);
+		s = salt;
+	}
+	snprintf(out, sizeof(out), "$krb5pa$%s$%s$%s$%s$%s", e, u, r, s, tc);
 
-	strnzcpy(out, ciphertext, sizeof(out));
 	data = out + strlen(out) - 2 * (CHECKSUM_SIZE + TIMESTAMP_SIZE) - 1;
 	strlwr(data);
 
